package sun.net.www.http;

import java.net.URL;
import java.util.Hashtable;

public class KeepAliveCache extends Hashtable {
   static int MAXCONNS = Integer.getInteger("http.maxConnections", 2);
   static final int LIFETIME = 5000;
   static final int PROXY_LIFETIME = 10000;

   public synchronized void put(URL var1, HttpClient var2) {
      KeepAliveKey var3 = new KeepAliveKey(var1);
      ClientVector var4 = (ClientVector)super.get(var3);
      if (var4 == null) {
         var4 = new ClientVector(this, var3, var2.usingProxy ? 10000 : 5000);
         var4.put(var2);
         super.put(var3, var4);
         Thread var5 = new Thread(var4, "Keep-Alive-Timer:" + var1.getHost());
         var5.setPriority(8);
         var5.start();
      } else {
         var4.put(var2);
      }
   }

   synchronized void removeVector(KeepAliveKey var1) {
      super.remove(var1);
   }

   public Object get(URL var1) {
      KeepAliveKey var2 = new KeepAliveKey(var1);
      ClientVector var3 = (ClientVector)super.get(var2);
      return var3 == null ? null : var3.get();
   }
}
