package sun.net.www.protocol.doc;

import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLStreamHandler;

public class Handler extends URLStreamHandler {
   static String base = System.getProperty("doc.url");
   static String installDirectory;

   public synchronized URLConnection openConnection(URL var1) throws IOException {
      String var2 = var1.getFile();
      var2 = installDirectory + var2;
      File var3 = new File(var2);
      if (var3 != null && var3.exists() && !var3.isDirectory()) {
         return new DocURLConnection(var1);
      } else {
         URLConnection var4 = null;

         URL var5;
         try {
            var2 = var1.getFile();
            if (var2.charAt(0) == '/') {
               var2 = var2.substring(1);
            }

            var5 = new URL(base + var2);
         } catch (MalformedURLException var6) {
            var5 = null;
         }

         if (var5 != null) {
            var4 = var5.openConnection();
         }

         if (var4 == null) {
            throw new IOException("Can't find file for URL: " + var1.toExternalForm());
         } else {
            return var4;
         }
      }
   }

   static {
      if (base == null) {
         base = "http://java.sun.com/HotJava/";
      } else if (base.charAt(base.length() - 1) != '/') {
         base = base + "/";
      }

      installDirectory = System.getProperty("hotjava.home");
      if (installDirectory == null) {
         installDirectory = "/usr/local/hotjava";
      }

   }
}
